
//
// TlbPdk v0.3.beta
//
// Copyright (C) 2005 by Alexander Kuznetsov (fiw@mail.ru)
//

{$DEFINE DEBUG}

unit TlbPdk;

interface

uses ActiveX, Classes, ComCtrls, ComObj, Windows;

// Type Library based on TlbSdk.idl

const

  IID_ITlbContainer: TGUID = '{b079767b-8c8a-434c-b59b-bbb399c4e4a6}';
  IID_ITlbButton   : TGUID = '{ab1982df-9da2-4fb4-9695-f23fb1f6e85f}';

  CTS_LARGEICONS = $00000001;
  CTS_ISMENU     = $00000002;
  CTS_SHOWARROWS = $00000004;
  CTS_SHOWTEXT   = $00000008;

type

  ITlbContainer = interface;
  ITlbButton    = interface;

  CONTAINER_STYLE = TOleEnum;

  ENUM_CHILDS = packed record
    Name     : PWideChar;
    childData: Pointer;
    enumData : Pointer;
  end;

  CONTAINER_PARAMS_V1 = packed record
    cbSize    : LongInt;
    dwViewMode: LongInt;
    style     : LongInt;
    bkColor   : TColorRef;
    hItemFont : THandle;
    dwLCID    : LongWord;
  end;

  CONTAINER_PARAMS_V2 = packed record
    cbSize    : LongInt;
    dwViewMode: LongInt;
    style     : LongInt;
    bkColor   : TColorRef;
    hItemFont : THandle;
    dwLCID    : LongWord;
    dwIconSize: LongWord;
  end;

  CONTAINER_PARAMS = packed record
    cbSize    : LongInt;
    dwViewMode: LongInt;
    style     : LongInt;
    bkColor   : TColorRef;
    hItemFont : THandle;
    dwLCID    : LongWord;
    dwIconSize: LongWord;
  end;

  BUTTONINFO = packed record
    dwMask     : LongWord;
    dwModeFlags: LongWord;
    dwActions  : LongWord;
    szBtnSize  : TSize;
    hIcon      : HICON;
    strData    : array[0..499] of AnsiChar;
  end;

  PHKM_DATA = ^HKM_DATA;
  HKM_DATA = packed record
    id      : LongWord;
    Name    : array[0..259] of WideChar;
    hotKey  : Word;
    hotKeyID: LongWord;
  end;

  CREATE_CHILDS = packed record
    parent   : ITlbButton;
    childData: Pointer;
    child    : ITlbButton;
  end;

  COMPARE_BUTTONS = packed record
    btn1  : ITlbButton;
    btn2  : ITlbButton;
    fnc   : LongWord;
    result: LongInt;
  end;

  PDRAW_TIPS_ICON = ^DRAW_TIPS_ICON;
  DRAW_TIPS_ICON = packed record
    hDC: HDC;
    pt : TPoint;
  end;

  QUERY_ARRANGE_MENU = packed record
    sortID: LongInt;
    Name  : PWideChar;
  end;

  ITlbContainer = interface(IUnknown)
    ['{b079767b-8c8a-434c-b59b-bbb399c4e4a6}']
    function GetParams(out retVal: CONTAINER_PARAMS): HRESULT; stdcall;
    function GetBandWND: HWND; stdcall;
    function SaveButton: HRESULT; stdcall;
    function GetLCID: LongWord; stdcall;
    function GetIconPoint(var ptIcon: TPoint): HRESULT; stdcall;
    function DrawItemText(dc: HDC; var rc: TRect; text: PAnsiChar): HRESULT; stdcall;
    function GetTextProps(var rcMargins: TRect; var color: TColorRef): HRESULT; stdcall;
    function UpdateButtonInfo(flags: LongInt): HRESULT; stdcall;
    function Invoke(id: LongWord; wParam: WPARAM; lParam: LPARAM): HRESULT; stdcall;
  end;

  ITlbButton = interface(IUnknown)
    ['{ab1982df-9da2-4fb4-9695-f23fb1f6e85f}']
    function Load(const data: IStream): HRESULT; stdcall;
    function Save(const data: IStream): HRESULT; stdcall;
    function SetRect(const rcItem: TRect): HRESULT; stdcall;
    function SetContainer(const cont: ITlbContainer): HRESULT; stdcall;
    function SetID(btnID: LongInt): HRESULT; stdcall;
    function Draw(hDC: HDC; const rcItem: TRect): HRESULT; stdcall;
    function OnMouseOver(keys, x, y: LongInt): HRESULT; stdcall;
    function OnMouseLeave(keys: LongInt): HRESULT; stdcall;
    function OnMouseEnter(keys, x, y: LongInt): HRESULT; stdcall;
    function Create(const data: IStream): HRESULT; stdcall;
    function StateChanged(state: LongInt; out needRedraw: LongInt): HRESULT; stdcall;
    function OnLButtonDown(key, x, y: LongInt): HRESULT; stdcall;
    function OnLButtonUp(key, x, y: LongInt): HRESULT; stdcall;
    function Run: HRESULT; stdcall;
    function DoAction(action: LongInt): HRESULT; stdcall;
    function SetName(szName: PWideChar): HRESULT; stdcall;
    function QueryContextMenu(hMenu: HMENU; index, cmdFirst, cmdLast: LongInt): LongInt; stdcall;
    function InvokeCommand(id: LongInt): HRESULT; stdcall;
    function SetLCID(dwLCID: LongWord; hResModule: HMODULE): HRESULT; stdcall;
    function GetIconLocation(szLocation: PAnsiChar): HRESULT; stdcall;
    function SetIconLocation(szLocation: PAnsiChar): HRESULT; stdcall;
    function GetButtonInfo(var btninfo: BUTTONINFO): HRESULT; stdcall;
    function Invoke(id: LongWord; wParam: WPARAM; lParam: LPARAM): HRESULT; stdcall;
  end;

// Constants based on TlbPdk.h

const

  HOTKEY_MOD_SHIFT   = $0100;
  HOTKEY_MOD_CONTROL = $0200;
  HOTKEY_MOD_ALT     = $0400;
  HOTKEY_MOD_WIN     = $2000;

  // Object types for CONTAINER_CMD_GETSAVEDPATH
  OT_ICONS       = $00;
  OT_PLUGINFILES = $01;

  // Constants for ITlbContainer.Invoke
  CONTAINER_CMD_SETHOTKEY        = 2;  // wParam - hotkey code, lParam - hotkey ID
  CONTAINER_CMD_ISVISIBLE        = 3;  // (BOOL* ) lParam
  CONTAINER_CMD_HIDE             = 4;  // hide button
  CONTAINER_CMD_SHOW             = 5;  // show button
  CONTAINER_CMD_CREATEWNDREQUEST = 6;  // request for creating window
  CONTAINER_CMD_OPENWINDOW       = 7;  //
  CONTAINER_CMD_KILLFOCUS        = 8;  // notify parent about WM_KILFOCUS
  CONTAINER_CMD_RBUTTONUP        = 9;  // notify parent about WM_RBUTTONUP
  CONTAINER_CMD_GETSAVEDPATH     = 10; // wParam - object type; lParam - LPWSTR pointer to string
  CONTAINER_CMD_SETSTATE         = 11; // wParam - state of button

  // Constants for ITlbContainer.UpdateButtonInfo
  UPDATE_SIZE    = $01;
  UPDATE_REDRAW  = $02;
  UPDATE_TOOLTIP = $04;

  // Constants for BUTTONINFO.dwMask
  BTNINFO_MASK_MODEFLAG     = $01;
  BTNINFO_MASK_ACTIONS      = $02;
  BTNINFO_MASK_SIZE         = $04;
  BTNINFO_MASK_ICON         = $08;
  BTNINFO_MASK_SELECTEDICON = $10;
  BTNINFO_MASK_DESCRIPTION  = $20;
  BTNINFO_MASK_TEXT         = $40;
  BTNINFO_MASK_ACTUALSIZE   = $80;

  // Constants for BUTTONINFO.dwModeFlags
  BTN_FLAG_PLANE            = $00000001;
  BTN_FLAG_STOPDRAG         = $00000002;
  BTN_FLAG_COLAPCEONRUN     = $00000004;
  BTN_FLAG_NOTIPS           = $00000008;
  BTN_FLAG_SUPPORTSAVEDICON = $00000010;
  BTN_FLAG_SUPPORTPNGICONS  = $00000020;
  BTN_FLAG_INPLACERENAME    = $00000040;

  BTN_FLAG_UNICODE          = $00000080;

  // Constants for BUTTONINFO.dwActions
  CTMS_PROPERTIES   = $01;
  CTMS_RENAME       = $02;
  CTMS_CHANGEICON   = $04;
  CTMS_HOVERRUN     = $20;
  CTMS_FINDTARGET   = $80;
  CTMS_OPENFOLDER   = $100;
  CTMS_NODELETE     = $200;
  CTMS_NOSELFDELETE = $400;
  CTMS_RESETICON    = $800;
  CTMS_SETIMAGE     = $1000;
  CTMS_ABOUT        = $2000;
  CTMS_DELETE       = $4000;

  // Button states
  BTN_S_PUSHED   = $01;
  BTN_S_SELECTED = $02;
  BTN_S_INMENU   = $04;
  BTN_S_INACTION = $08;

  // Constans for button state
  TS_STATE_NORMAL       = $01;
  TS_STATE_OVER         = $02;
  TS_STATE_DOWN         = $03;
  TS_STATE_OPENACTIVE   = $04;
  TS_STATE_OPENINACTIVE = $05;
  TS_STATE_COUNT        = TS_STATE_OPENINACTIVE;

  // Constants for button type
  TS_ITEM_BTN                = $0001;
  TS_ITEM_MENUITEM           = $0002;
  TS_ITEM_MENUBTN            = $0004;
  TS_ITEM_MENUSEPARATOR      = $0005;
  TS_ITEM_SEPARATOR          = $0006;
  TS_ITEM_TEXTSEPARATOR      = $0007;
  TS_ITEM_MENUITEMSUBMENU    = $0008;
  TS_ITEM_BTNVERT            = $0009;
  TS_ITEM_MENUBTNVERT        = $000a;
  TS_ITEM_SEPARATORVERT      = $000b;
  TS_ITEM_CAPTION            = $000c;
  TS_ITEM_CHEVRON            = $000d;
  TS_ITEM_CHEVRONVERT        = $000e;
  TS_ITEM_TOPMENUSCROLLER    = $000f;
  TS_ITEM_BOTTOMMENUSCROLLER = $0010;
  TS_ITEM_MENUBACKGROUND     = $0020;

  TS_ITEM_SBTOP    = $0011;
  TS_ITEM_SBBOTTOM = $0012;
  TS_ITEM_SB       = $0013;
  TS_ITEM_SBROLLER = $0014;

  TS_ITEM_SHOWTEXT   = $000800;
  TS_ITEM_ALWAYSBTN  = $001000;
  TS_ITEM_EXPANDMARK = $002000;
  TS_ITEM_RUNMARK    = $004000;
  TS_ITEM_ICONONLY   = $008000;
  TS_ITEM_ONTOOLBAR  = $000100;
  TS_ITEM_INMENU     = $010000;
  TS_ITEM_NOICON     = $020000;
  TS_ITEM_NOTEXT     = $040000;

  // for TBTN_INVOKE_GETMENUFLAGS
  MENU_F_NORENAME = $00001;

  // Constants for ITlbButton.Invoke
  TBTN_INVOKE_GETTOOLTIPSCOUNT = 1;  // wParam ignored, (int* ) lParam - tooltips count
  TBTN_INVOKE_GETTOOLTIPRECT   = 2;  // wParam - zero based tooltip index, (RECT* ) lParam - rectangle of tooltip
  TBTN_INVOKE_GETTOOLTIPTEXT   = 3;  // wParam - zero based tooltip index, (char* ) lParam - Text of tooltip (1024 max)
  TBTN_INVOKE_ONHOTKEY         = 25; // lParam - ID of the hotkey
  TBTN_INVOKE_QUERYHOTKEY      = 4;  // wParam - index of the hotkey (HKM_DATA* ) lParam
  TBTN_INVOKE_HOTKEYSCOUNT     = 5;  // (int* ) lParam - hotkeys count
  TBTN_INVOKE_CREATEWND        = 6;  // Create child windows here
  TBTN_INVOKE_ONHIDE           = 7;  // The button become hidden
  TBTN_INVOKE_ONSHOW           = 8;  // The button become visible

  TBTN_INVOKE_ISMENU             = 9;  // (BOOL* ) lParam - TRUE if menu
  TBTN_INVOKE_GETCHANGESHANDLE   = 10; // (HANDLE* ) lParam - changes handle
  TBTN_INVOKE_PREPARECHANGES     = 11; // (HANDLE) lParam - changes handle
  TBTN_INVOKE_CLOSECHANGESHANDLE = 12; // (HANDLE) lParam - changes handle
  TBTN_INVOKE_FIRSTCHILDDATA     = 13; // (ENUM_CHILDS* ) lParam
  TBTN_INVOKE_NEXTCHILDDATA      = 14; // (ENUM_CHILDS* ) lParam
  TBTN_INVOKE_FREECHILDDATA      = 15; // (ENUM_CHILDS* ) lParam
  TBTN_INVOKE_CREATECHILD        = 16; // (CREATE_CHILDS* ) lParam
  TBTN_INVOKE_READCHANGES        = 17; // (UINT* ) lParam: 0 - no changes, 1 - child changed, 2 - child deleted
  TBTN_INVOKE_GETCHILDUID        = 18; // (LPTSTR) lParam - unique child string
  TBTN_INVOKE_SUPPORTSORT        = 19; // (BOOL* ) lParam - TRUE if plugin supports custom arrange of items
  TBTN_INVOKE_COMPAREBUTTONS     = 20; // (COMPARE_BUTTONS* ) lParam
  TBTN_INVOKE_QUERYARRANGEMENU   = 21; // (QUERY_ARRANGE_MENU* ) lParam

  TBTN_INVOKE_GETTIPSTEXT     = 22; // wParam - zero based tooltip index, (LPWSTR* ) lParam - Text of tooltip use CoTaskMemAlloc to allocate memory
  TBTN_INVOKE_GETTIPSICON     = 23; // wParam - zero based tooltip index, (HICON* ) lParam - Text of tooltip (1024 max)
  TBTN_INVOKE_GETTIPSCAPTION  = 24; // wParam - zero based tooltip index, (LPWSTR* ) lParam - Text of tooltip use CoTaskMemAlloc to allocate memory
  TBTN_INVOKE_GETMENUFLAGS    = 26; // (UINT* ) lParam - flags
  TBTN_INVOKE_GETNAME         = 27; // (LPWSTR) lParam - Name of button (max name size is MAX_PATH)
  TBTN_INVOKE_GETTIPSICONSIZE = 28; // wParam - zero based tooltip index, (int*) lParam - size of icon
  TBTN_INVOKE_DRAWTIPSICON    = 29; // wParam - zero based tooltip index, (DRAW_TIPS_ICON*) lParam - size of icon

// Objects

const

  CATID_TlbButtons: TGUID = '{49e86696-eaa6-45a2-9480-c78c013b9713}';

type

  TToolTip = packed record
    Caption: AnsiString;
    Text   : AnsiString;
    Icon   : HICON;
  end;

  TTlbButton = class(TComObject, ITlbButton)
  private
    FRect: TRect;
    FTlbContainer: ITlbContainer;
    FID: LongInt;
    FName: AnsiString;

    FToolTip: TToolTip;
    FHotKey: Word;

    function TlbBtnLoad(const data: IStream): HRESULT; stdcall;
    function TlbBtnSave(const data: IStream): HRESULT; stdcall;
    function TlbBtnSetRect(const rcItem: TRect): HRESULT; stdcall;
    function TlbBtnSetContainer(const cont: ITlbContainer): HRESULT; stdcall;
    function TlbBtnSetID(btnID: LongInt): HRESULT; stdcall;
    function TlbBtnDraw(hDC: HDC; const rcItem: TRect): HRESULT; stdcall;
    function TlbBtnOnMouseOver(keys, x, y: LongInt): HRESULT; stdcall;
    function TlbBtnOnMouseLeave(keys: LongInt): HRESULT; stdcall;
    function TlbBtnOnMouseEnter(keys, x, y: LongInt): HRESULT; stdcall;
    function TlbBtnCreate(const data: IStream): HRESULT; stdcall;
    function TlbBtnStateChanged(state: LongInt; out needRedraw: LongInt): HRESULT; stdcall;
    function TlbBtnOnLButtonDown(key, x, y: LongInt): HRESULT; stdcall;
    function TlbBtnOnLButtonUp(key, x, y: LongInt): HRESULT; stdcall;
    function TlbBtnRun: HRESULT; stdcall;
    function TlbBtnDoAction(action: LongInt): HRESULT; stdcall;
    function TlbBtnSetName(szName: PWideChar): HRESULT; stdcall;
    function TlbBtnQueryContextMenu(hMenu: HMENU; index, cmdFirst, cmdLast: LongInt): LongInt; stdcall;
    function TlbBtnInvokeCommand(id: LongInt): HRESULT; stdcall;
    function TlbBtnSetLCID(dwLCID: LongWord; hResModule: HMODULE): HRESULT; stdcall;
    function TlbBtnGetIconLocation(szLocation: PAnsiChar): HRESULT; stdcall;
    function TlbBtnSetIconLocation(szLocation: PAnsiChar): HRESULT; stdcall;
    function TlbBtnGetButtonInfo(var btninfo: BUTTONINFO): HRESULT; stdcall;
    function TlbBtnInvoke(id: LongWord; wParam: WPARAM; lParam: LPARAM): HRESULT; stdcall;

    function GetHotKey: TShortCut;
    procedure SetHotKey(Value: TShortCut);

  protected
    function ITlbButton.Load             = TlbBtnLoad;
    function ITlbButton.Save             = TlbBtnSave;
    function ITlbButton.SetRect          = TlbBtnsetRect;
    function ITlbButton.SetContainer     = TlbBtnSetContainer;
    function ITlbButton.SetID            = TlbBtnSetID;
    function ITlbButton.Draw             = TlbBtnDraw;
    function ITlbButton.OnMouseOver      = TlbBtnOnMouseOver;
    function ITlbButton.OnMouseLeave     = TlbBtnOnMouseLeave;
    function ITlbButton.OnMouseEnter     = TlbBtnOnMouseEnter;
    function ITlbButton.Create           = TlbBtnCreate;
    function ITlbButton.StateChanged     = TlbBtnStateChanged;
    function ITlbButton.OnLButtonDown    = TlbBtnOnLButtonDown;
    function ITlbButton.OnLButtonUp      = TlbBtnOnLButtonUp;
    function ITlbButton.Run              = TlbBtnRun;
    function ITlbButton.DoAction         = TlbBtnDoAction;
    function ITlbButton.SetName          = TlbBtnSetName;
    function ITlbButton.QueryContextMenu = TlbBtnQueryContextMenu;
    function ITlbButton.InvokeCommand    = TlbBtnInvokeCommand;
    function ITlbButton.SetLCID          = TlbBtnSetLCID;
    function ITlbButton.GetIconLocation  = TlbBtnGetIconLocation;
    function ITlbButton.SetIconLocation  = TlbBtnSetIconLocation;
    function ITlbButton.GetButtonInfo    = TlbBtnGetButtonInfo;
    function ITlbButton.Invoke           = TlbBtnInvoke;
  public
    function Load(const data: IStream): Boolean; virtual;
    function Save(const data: IStream): Boolean; virtual;
    procedure OnDraw(hDC: HDC; const rcItem: TRect); virtual;
    function OnMouseOver(keys, x, y: LongInt): Boolean; virtual;
    function OnMouseLeave(keys: LongInt): Boolean; virtual;
    function OnMouseEnter(keys, x, y: LongInt): Boolean; virtual;
    function OnCreate: Boolean; virtual;
    function OnStateChanged(state: LongInt; out needRedraw: LongInt): Boolean; virtual;
    function OnLButtonDown(key, x, y: LongInt): Boolean; virtual;
    function OnLButtonUp(key, x, y: LongInt): Boolean; virtual;
    function OnRun: Boolean; virtual;
    function OnProperties: Boolean; virtual;
    function OnRename: Boolean; virtual;
    function OnAbout: Boolean; virtual;
    function OnDelete: Boolean; virtual;
    function QueryContextMenu(hMenu: HMENU; index, cmdFirst, cmdLast: LongInt): LongInt; virtual;
    function OnContextMenuCommand(id: LongInt): Boolean; virtual;
    function GetSupportedActions: LongWord; virtual;
    function GetModeFlags: LongWord; virtual;
    procedure GetSize(var sz: TSize; actual: Boolean); virtual;
    procedure GetButtonText(text: PAnsiChar); virtual;

    function GetTipsIconSize(tipID: LongInt): LongInt; virtual;
    procedure DrawTipsIcon(hDC: HDC; pt: TPoint; tipID: LongInt); virtual;
    function GetTipIcon(tipID: LongInt): HICON; virtual;
    function GetTipCaption(tipID: LongInt): PWideChar; virtual;
    function GetTipsCount: LongInt; virtual;
    procedure GetTipRect(intID: LongInt; out rcTip: TRect); virtual;
    function GetTipText(tipID: LongInt): PWideChar; virtual;

    function GetHotKeyData(idx: LongInt; out hkData: HKM_DATA): Boolean; virtual;
    function GetHotKeysCount: LongInt; virtual;
    procedure OnHotKey(hkID: LongWord); virtual;
//    procedure SetHotKey(hk, hkID: LongWord); virtual;

  published
    property Rect: TRect read FRect write FRect;
    property TlbContainer: ITlbContainer read FTlbContainer write FTlbContainer;
    property ID: LongInt read FID write FID;
    property Name: AnsiString read FName write FName;

    property ToolTip: TToolTip read FToolTip write FToolTip;
    property HotKey: TShortCut read GetHotKey write SetHotKey;

  end;

  TTlbButtonFactory = class(TComObjectFactory)
  public
    constructor Create(ComServer: TComServerObject; ComClass: TComClass; const ClassID: TGUID; const Description: AnsiString);
    procedure UpdateRegistry(Register: Boolean); override;
  end;

implementation

uses SysUtils;

// TTlbButton

function TTlbButton.TlbBtnLoad(const data: IStream): HRESULT;
begin
  {$IFDEF DEBUG}OutputDebugString('ITlbButton.Load');{$ENDIF}
  if Load(data) then
    Result := S_OK
  else
    Result := S_FALSE;
end;

function TTlbButton.TlbBtnSave(const data: IStream): HRESULT;
begin
  {$IFDEF DEBUG}OutputDebugString('ITlbButton.Save');{$ENDIF}
  if Save(data) then
    Result := S_OK
  else
    Result := S_FALSE;
end;

function TTlbButton.TlbBtnSetRect(const rcItem: TRect): HRESULT;
begin
  {$IFDEF DEBUG}OutputDebugString('ITlbButton.SetRect');{$ENDIF}
  Rect := rcItem;
  Result := S_OK;
end;

function TTlbButton.TlbBtnSetContainer(const cont: ITlbContainer): HRESULT;
begin
  {$IFDEF DEBUG}OutputDebugString('ITlbButton.SetContainer');{$ENDIF}
  TlbContainer := cont;
  TlbContainer._Release;
  Result := S_OK;
end;

function TTlbButton.TlbBtnSetID(btnID: LongInt): HRESULT;
begin
  {$IFDEF DEBUG}OutputDebugString(PAnsiChar(Format('ITlbButton.SetID: %d', [btnID])));{$ENDIF}
  ID := btnID;
  Result := S_OK;
end;

function TTlbButton.TlbBtnDraw(hDC: HDC; const rcItem: TRect): HRESULT;
begin
  {$IFDEF DEBUG}OutputDebugString('ITlbButton.Draw');{$ENDIF}
  OnDraw(hDC, rcItem);
  Result := S_OK;
end;

function TTlbButton.TlbBtnOnMouseOver(keys, x, y: LongInt): HRESULT;
begin
  {$IFDEF DEBUG}OutputDebugString('ITlbButton.OnMouseOver');{$ENDIF}
  if OnMouseOver(keys, x, y) then
    Result := S_OK
  else
    Result := S_FALSE;
end;

function TTlbButton.TlbBtnOnMouseLeave(keys: LongInt): HRESULT;
begin
  {$IFDEF DEBUG}OutputDebugString('ITlbButton.OnMouseLeave');{$ENDIF}
  if OnMouseLeave(keys) then
    Result := S_OK
  else
    Result := S_FALSE;
end;

function TTlbButton.TlbBtnOnMouseEnter(keys, x, y: LongInt): HRESULT;
begin
  {$IFDEF DEBUG}OutputDebugString('ITlbButton.OnMouseEnter');{$ENDIF}
  if OnMouseEnter(keys, x, y) then
    Result := S_OK
  else
    Result := S_FALSE;
end;

function TTlbButton.TlbBtnCreate(const data: IStream): HRESULT;
begin
  {$IFDEF DEBUG}OutputDebugString('ITlbButton.Create');{$ENDIF}
  TlbContainer._AddRef;
  if OnCreate then
    Result := TlbBtnSave(data)
  else
    Result := S_FALSE;
end;

function TTlbButton.TlbBtnStateChanged(state: LongInt; out needRedraw: LongInt): HRESULT;
begin
  {$IFDEF DEBUG}OutputDebugString('ITlbButton.StateChanged');{$ENDIF}
  if OnStateChanged(state, needRedraw) then
    Result := S_OK
  else
    Result := S_FALSE;
end;

function TTlbButton.TlbBtnOnLButtonDown(key, x, y: LongInt): HRESULT;
begin
  {$IFDEF DEBUG}OutputDebugString('ITlbButton.OnLButtonDown');{$ENDIF}
  if OnLButtonDown(key, x, y) then
    Result := S_OK
  else
    Result := S_FALSE;
end;

function TTlbButton.TlbBtnOnLButtonUp(key, x, y: LongInt): HRESULT;
begin
  {$IFDEF DEBUG}OutputDebugString('ITlbButton.OnLButtonUp');{$ENDIF}
  if OnLButtonUp(key, x, y) then
    Result := S_OK
  else
    Result := S_FALSE;
end;

function TTlbButton.TlbBtnRun: HRESULT;
begin
  {$IFDEF DEBUG}OutputDebugString('ITlbButton.Run');{$ENDIF}
  if OnRun then
    Result := S_OK
  else
    Result := S_FALSE;
end;

function TTlbButton.TlbBtnDoAction(action: LongInt): HRESULT;
var
  res: Boolean;
begin
  {$IFDEF DEBUG}OutputDebugString(PAnsiChar(Format('ITlbButton.DoAction: %x', [action])));{$ENDIF}
  res := False;
  case action of
    CTMS_PROPERTIES: res := OnProperties;
    CTMS_RENAME    : res := OnRename;
    CTMS_ABOUT     : res := OnAbout;
    CTMS_DELETE    : res := OnDelete;
  end;
  if res then
    Result := S_OK
  else
    Result := S_FALSE;
end;

function TTlbButton.TlbBtnSetName(szName: PWideChar): HRESULT;
begin
  {$IFDEF DEBUG}OutputDebugString(PAnsiChar(Format('ITlbButton.SetName: %s', [szName])));{$ENDIF}
  Name := szName;
  Result := S_OK;
end;

function TTlbButton.TlbBtnQueryContextMenu(hMenu: HMENU; index, cmdFirst, cmdLast: LongInt): LongInt;
begin
  {$IFDEF DEBUG}OutputDebugString('ITlbButton.QueryContextMenu');{$ENDIF}
  Result := QueryContextMenu(hMenu, index, cmdFirst, cmdLast);
end;

function TTlbButton.TlbBtnInvokeCommand(id: LongInt): HRESULT;
begin
  {$IFDEF DEBUG}OutputDebugString('ITlbButton.InvokeCommand');{$ENDIF}
  if OnContextMenuCommand(id) then
    Result := S_OK
  else
    Result := S_FALSE;
end;

function TTlbButton.TlbBtnSetLCID(dwLCID: LongWord; hResModule: HMODULE): HRESULT;
begin
  {$IFDEF DEBUG}OutputDebugString('ITlbButton.SetLCID');{$ENDIF}
  //
  Result := S_OK;
end;

function TTlbButton.TlbBtnGetIconLocation(szLocation: PAnsiChar): HRESULT;
begin
  {$IFDEF DEBUG}OutputDebugString('ITlbButton.GetIconLocation');{$ENDIF}
  //
  Result := S_FALSE;
end;

function TTlbButton.TlbBtnSetIconLocation(szLocation: PAnsiChar): HRESULT;
begin
  {$IFDEF DEBUG}OutputDebugString('ITlbButton.SetIconLocation');{$ENDIF}
  //
  Result := S_FALSE;
end;

function TTlbButton.TlbBtnGetButtonInfo(var btninfo: BUTTONINFO): HRESULT;
begin
  {$IFDEF DEBUG}OutputDebugString('ITlbButton.GetButtonInfo');{$ENDIF}
  if Boolean(btninfo.dwMask and BTNINFO_MASK_ACTIONS) then
    btninfo.dwActions := GetSupportedActions;
  if Boolean(btninfo.dwMask and BTNINFO_MASK_MODEFLAG) then
    btninfo.dwModeFlags := GetModeFlags or BTN_FLAG_UNICODE;
  if Boolean(btninfo.dwMask and BTNINFO_MASK_SIZE) then
    GetSize(btninfo.szBtnSize, False);
  if Boolean(btninfo.dwMask and BTNINFO_MASK_ACTUALSIZE) then
    GetSize(btninfo.szBtnSize, True);
  if Boolean(btninfo.dwMask and BTNINFO_MASK_TEXT) then
    GetButtonText(@btninfo.strData);
  Result := S_OK;
end;

function TTlbButton.TlbBtnInvoke(id: LongWord; wParam: WPARAM; lParam: LPARAM): HRESULT;
var
  icSZ: PLongInt;
  dIc: PDRAW_TIPS_ICON;
  lpIcon: ^HICON;
  text: ^PWideChar;
  tipsCount: PLongInt;
  rcTip: PRect;
  hkd: PHKM_DATA;
  cnt: PLongint;
begin
  {$IFDEF DEBUG}OutputDebugString(PAnsiChar(Format('ITlbButton.Invoke: %d', [id])));{$ENDIF}
  Result := S_FALSE;
  case id of
    TBTN_INVOKE_GETTIPSICONSIZE: begin
      {$IFDEF DEBUG}OutputDebugString(' - TBTN_INVOKE_GETTIPSICONSIZE');{$ENDIF}
      icSZ := Pointer(lParam);
      icSZ^ := GetTipsIconSize(wParam);
      Result := S_OK;
    end;
    TBTN_INVOKE_DRAWTIPSICON: begin
      {$IFDEF DEBUG}OutputDebugString(' - TBTN_INVOKE_DRAWTIPSICON');{$ENDIF}
      dIc := Pointer(lParam);
      DrawTipsIcon(dIc^.hDC, dIc^.pt, wParam);
      Result := S_OK;
    end;
    TBTN_INVOKE_GETTIPSICON: begin
      {$IFDEF DEBUG}OutputDebugString(' - TBTN_INVOKE_GETTIPSICON');{$ENDIF}
      lpIcon := Pointer(lParam);
      lpIcon^ := GetTipIcon(wParam);
      Result := S_OK;
    end;
    TBTN_INVOKE_GETTIPSCAPTION: begin
      {$IFDEF DEBUG}OutputDebugString(' - TBTN_INVOKE_GETTIPSCAPTION');{$ENDIF}
      text := Pointer(lParam);
      text^ := GetTipCaption(wParam);
      if Assigned(text^) then
        Result := S_OK;
    end;
    TBTN_INVOKE_GETTOOLTIPSCOUNT: begin
      {$IFDEF DEBUG}OutputDebugString(' - TBTN_INVOKE_GETTOOLTIPSCOUNT');{$ENDIF}
      tipsCount := Pointer(lParam);
      tipsCount^ := GetTipsCount;
      Result := S_OK;
    end;
    TBTN_INVOKE_GETTOOLTIPRECT: begin
      {$IFDEF DEBUG}OutputDebugString(' - TBTN_INVOKE_GETTOOLTIPRECT');{$ENDIF}
      rcTip := Pointer(lParam);
      GetTipRect(wParam, rcTip^);
      Result := S_OK;
    end;
    TBTN_INVOKE_GETTIPSTEXT: begin
      {$IFDEF DEBUG}OutputDebugString(' - TBTN_INVOKE_GETTIPSTEXT');{$ENDIF}
      text := Pointer(lParam);
      text^ := GetTipText(wParam);
      if Assigned(text^) then
        Result := S_OK;
    end;
    TBTN_INVOKE_QUERYHOTKEY: begin
      {$IFDEF DEBUG}OutputDebugString(' - TBTN_INVOKE_QUERYHOTKEY');{$ENDIF}
      hkd := Pointer(lParam);
      if GetHotKeyData(wParam, hkd^) then
        Result := S_OK;
    end;
    TBTN_INVOKE_HOTKEYSCOUNT: begin
      {$IFDEF DEBUG}OutputDebugString(' - TBTN_INVOKE_HOTKEYSCOUNT');{$ENDIF}
      cnt := Pointer(lParam);
      cnt^ := GetHotKeysCount;
      Result := S_OK;
    end;
    TBTN_INVOKE_ONHOTKEY: begin
      {$IFDEF DEBUG}OutputDebugString(' - TBTN_INVOKE_ONHOTKEY');{$ENDIF}
      OnHotKey(lParam);
      Result := S_OK;
    end;

  end;
end;

// -----

function TTlbButton.GetHotKey: TShortCut;
var
  Modifiers: THKModifiers;
begin
  Byte(Modifiers) := LoWord(HiByte(FHotKey));
  Result := LoWord(LoByte(FHotKey));
  if hkShift in Modifiers then Inc(Result, scShift);
  if hkCtrl  in Modifiers then Inc(Result, scCtrl);
  if hkAlt   in Modifiers then Inc(Result, scAlt);
end;

procedure TTlbButton.SetHotKey(Value: TShortCut);
var
  Modifiers: THKModifiers;
begin
  Modifiers := [];
  if Value and scShift <> 0 then Include(Modifiers, hkShift);
  if Value and scCtrl  <> 0 then Include(Modifiers, hkCtrl);
  if Value and scAlt   <> 0 then Include(Modifiers, hkAlt);
  FHotKey := MakeWord(Byte(Value and not (scShift + scCtrl + scAlt)), Byte(Modifiers));
  TlbContainer.Invoke(CONTAINER_CMD_SETHOTKEY, FHotKey, 0);
end;

// -----

function TTlbButton.Load(const data: IStream): Boolean;
begin
  Result := True;
end;

function TTlbButton.Save(const data: IStream): Boolean;
begin
  Result := True;
end;

procedure TTlbButton.OnDraw(hDC: HDC; const rcItem: TRect);
begin
end;

function TTlbButton.OnMouseOver(keys, x, y: LongInt): Boolean;
begin
  Result := False;
end;

function TTlbButton.OnMouseLeave(keys: LongInt): Boolean;
begin
  Result := False;
end;

function TTlbButton.OnMouseEnter(keys, x, y: LongInt): Boolean;
begin
  Result := False;
end;

function TTlbButton.OnCreate: Boolean;
begin
  Result := True;
end;

function TTlbButton.OnStateChanged(state: LongInt; out needRedraw: LongInt): Boolean;
begin
  Result := False;
end;

function TTlbButton.OnLButtonDown(key, x, y: LongInt): Boolean;
begin
  Result := False;
end;

function TTlbButton.OnLButtonUp(key, x, y: LongInt): Boolean;
begin
  Result := False;
end;

function TTlbButton.OnRun: Boolean;
begin
  Result := False;
end;

function TTlbButton.OnProperties: Boolean;
begin
  Result := False;
end;

function TTlbButton.OnRename: Boolean;
begin
  Result := False;
end;

function TTlbButton.OnAbout: Boolean;
begin
  Result := False;
end;

function TTlbButton.OnDelete: Boolean;
begin
  Result := False;
end;

function TTlbButton.QueryContextMenu(hMenu: HMENU; index, cmdFirst, cmdLast: LongInt): LongInt;
begin
  Result := 0;
end;

function TTlbButton.OnContextMenuCommand(id: LongInt): Boolean;
begin
  Result := False;
end;

function TTlbButton.GetSupportedActions: LongWord;
begin
  Result := 0;
end;

function TTlbButton.GetModeFlags: LongWord;
begin
  Result := 0;
end;

procedure TTlbButton.GetSize(var sz: TSize; actual: Boolean);
begin
end;

procedure TTlbButton.GetButtonText(text: PAnsiChar);
begin
  //
end;

function TTlbButton.GetTipsIconSize(tipID: LongInt): LongInt;
begin
  Result := 32;
end;

procedure TTlbButton.DrawTipsIcon(hDC: HDC; pt: TPoint; tipID: LongInt);
begin
end;

function TTlbButton.GetTipCaption(tipID: LongInt): PWideChar;
begin
  if Boolean(Length(ToolTip.Caption)) then
    Result := StringToLPOLESTR(ToolTip.Caption)
  else
    Result := nil;
end;

function TTlbButton.GetTipIcon(tipID: LongInt): HICON;
begin
  Result := ToolTip.Icon;
end;

function TTlbButton.GetTipsCount: LongInt;
begin
  Result := 1;
end;

procedure TTlbButton.GetTipRect(intID: LongInt; out rcTip: TRect);
begin
  rcTip := Rect;
end;

function TTlbButton.GetTipText(tipID: LongInt): PWideChar;
begin
  if Boolean(Length(ToolTip.Text)) then
    Result := StringToLPOLESTR(ToolTip.Text)
  else
    Result := StringToLPOLESTR(Name);
end;

function TTlbButton.GetHotKeyData(idx: LongInt; out hkData: HKM_DATA): Boolean;
begin
  Result := False;
end;

function TTlbButton.GetHotKeysCount: LongInt;
begin
  Result := 1;
end;

procedure TTlbButton.OnHotKey(hkID: LongWord);
begin
end;
{
procedure TTlbButton.SetHotKey(hk, hkID: LongWord);
begin
  TlbContainer.Invoke(CONTAINER_CMD_SETHOTKEY, hk, hkID);
end;
}
// TTlbButtonFactory

constructor TTlbButtonFactory.Create(ComServer: TComServerObject; ComClass: TComClass; const ClassID: TGUID; const Description: AnsiString);
begin
  inherited Create(ComServer, ComClass, ClassID, '', Description, ciMultiInstance, tmApartment);
end;

procedure TTlbButtonFactory.UpdateRegistry(Register: Boolean);

  procedure RegisterComCat(Register: Boolean);
  var
    CatRegister: ICatRegister;
  begin
    CoInitialize(nil);
    if Succeeded(CoCreateInstance(CLSID_StdComponentCategoryMgr, nil, CLSCTX_INPROC_SERVER, ICatRegister, CatRegister)) then
      if Register then
        OleCheck(CatRegister.RegisterClassImplCategories(ClassID, 1, @CATID_TlbButtons))
      else
        OleCheck(CatRegister.UnRegisterClassImplCategories(ClassID, 1, @CATID_TlbButtons));
    CoUninitialize;
  end;

begin
  if Register then begin
    inherited UpdateRegistry(Register);
    RegisterComCat(Register);
  end else begin
    RegisterComCat(Register);
    DeleteRegKey(Format('CLSID\%s\Implemented Categories', [GUIDToString(ClassID)]));
    inherited UpdateRegistry(Register);
  end;
end;

end.
